#include "messages.h"

int EndMsgSystem(int queue)
{
    if (queue!=-1) return msgctl(queue,IPC_RMID,0);
}
int StartMsgSystem(int queue)
{
    return msgget((queue==-1)?IPC_PRIVATE:queue,0666|IPC_CREAT);
}

int GetMessage(int queue,struct EthMessage *msg)
{
    return msgrcv(queue,msg,sizeof(struct EthMessage)-4,0,IPC_NOWAIT);
}
int WaitMessage(int queue,struct EthMessage *msg)
{
    return msgrcv(queue,msg,sizeof(struct EthMessage)-4,0,0);
}

int SendMessage(int queue,struct EthMessage *msg)
{
    msg->type=1;
//    printf("Queue %d message %d size %d buffer %s\n",queue,msg,strlen(msg->buffer)+1,msg->buffer);
    return msgsnd(queue,msg,sizeof(struct EthMessage)-sizeof(long),0);
}

